#ifndef __EVALUATE_H_
#define __EVALUATE_H_

#include "board.h"
#include "player.h"
#define MIN(a,b) (a>b)?b:a
#define MAX(a,b) (a<b)?b:a


typedef struct ps {
  int MaxPawnFileBins[8];
  int MaxPawnColorBins[2];
  int MaxTotalPawns;
  int PawnRams;
  int MaxMostAdvanced[8];
  int MaxPassedPawns[8];
  int MinPawnFileBins[8];
  int MinMostBackward[8];
  
} pstruct;

int eval(const boardt* board);
int evalkingtropism( const boardt* board, int kingx, int kingy);
int evalrookbonus( const boardt* board, pstruct * pawnstuff);
int evaldevelopment(const boardt* board, pstruct* pawnstuff);
int evalbadbishops( const boardt* board, pstruct* pawnstuff, int x, int y);
int evalpawnstructure( const boardt* board, pstruct * pawnstuff);
void analyzepawnstructure( const boardt* board, pstruct* pawnstuff);



#endif
