#include "board.h"
#include "player.h"
#include "moves.h"
#include <stdio.h>
#include <stdlib.h>

/* we can have at most 30 different qualities of captures,
   6 kinds of check, and 2 noncapture moves.
   Here, I'm taling about different weights. 
*/ 

int sortedmoves(const boardt* board, move* moves){
  move m;
  move promo[22];
  int npromo = 0;
  move caps[30][MAXMOVES];
  move checks[6][MAXMOVES];
  move noncaps[2][MAXMOVES];
  int ncaps[30]={0};
  int nchecks[6] = {0};
  int nnoncaps[2] = {0};
  int attacker, attacked, index, nummoves=0, i, j, ii, jj, turn = board->nextturn;
  boardt nboard;
  
  for(i = 0; i < BSIZE; i++)
    for(j = 0; j < BSIZE; j++)
      if(COLORAT(board->b,i,j) == turn)
	for(ii = 0; ii < BSIZE; ii++)
	  for(jj = 0; jj < BSIZE; jj++){
		m.srcx = i;
		m.srcy = j;
		m.destx = ii;
		m.desty = jj;
	    if (COLORAT(board->b, ii, jj) != turn &&
		checky(board, m) && ((i != ii) || (j != jj))){
	      copyboard(board, &nboard);
	      
	      execute_move(&nboard, m, true);

	      /* execute move has flipped turn, but we want
		 to see if we moved into check, so flip again
		 temporarily */
	      nboard.nextturn = NEGATE(nboard.nextturn);
	      if (!check(&nboard)) {
		nboard.nextturn = NEGATE(nboard.nextturn);

		switch (RANKAT(board->b, i, j)){
		case KING: attacker = 0; break; 
		case QUEEN: attacker = 1; break;
		case ROOK: attacker = 2; break;
		case BISHOP:attacker = 3; break;
		case KNIGHT:attacker = 4; break;
		case PAWN:attacker = 5;
		}
		if(check(&nboard)){
		  m.flag = CHECK;
		  checks[attacker][nchecks[attacker]] = m;
		  nchecks[attacker]++;
		  continue;
		}
		else if((RANKAT(board->b, i, j) == PAWN) && (jj == 0 || jj == BSIZE-1)){
		  m.flag = PROMO;
		  m.promo = get_promotion(&nboard, ii, jj);
		  promo[npromo] = m;
		  npromo++;
		  continue;
		}
		else switch (RANKAT(board->b, ii, jj)) {
		case QUEEN: attacked = 5; break;
		case ROOK: attacked = 4; break;
		case BISHOP:attacked = 3; break;
		case KNIGHT:attacked = 2; break;
		case PAWN:attacked = 1; break;
		default:
		  m.flag = NONCAPTURE;
		  index = (((turn == WHITE) && (jj > j)) ||((turn == BLACK) && (jj < j)) )? 0 : 1;
		  noncaps[index][nnoncaps[index]] = m;
		  nnoncaps[index]++;
		  continue;
		  
		}
		m.flag = CAPTURE;
		index = attacked*6 - attacker -1;
		caps[index][ncaps[index]] = m;
		ncaps[index]++;
		
	      }
	    }
	    
	  }
  
  for(i = 0; i < 6; i++)
    for(j = 0; j < nchecks[i]; j++){
      moves[nummoves] = checks[i][j];
      nummoves++;
    }
  for(j = 0; j < npromo; j++){
    moves[nummoves] = promo[j];
    nummoves++;
  }
  
  for(i = 0; i < 30; i++)
    for(j = 0; j < ncaps[i]; j++){
      moves[nummoves] = caps[i][j];
      nummoves++;
    }
  for(i = 0; i < 2; i++)
    for(j = 0; j < nnoncaps[i]; j++){
      moves[nummoves] = noncaps[i][j];
      nummoves++;
    }
  
      
  return nummoves;
    

}


  

